// This script compares the results generated by running
// the particle analyzer on an an image that has particles
// with holes to the  results from measuring the overlay
// and ROI Manager ROIs.

  // Run particle analyze on AuPbSn40 sample image
  img = IJ.openImage("http://wsr.imagej.net/images/AuPbSn40.jpg");
  IJ.run("Clear Results", "");
  saveMeasurements = Analyzer.getMeasurements();
  Analyzer.setMeasurements(Measurements.ALL_STATS-Measurements.AREA_FRACTION);
  IJ.setAutoThreshold(img, "Huang");
  IJ.run(img, "Analyze Particles...", "  show=Overlay add clear");
  rt = ResultsTable.getResultsTable();
  rt = rt.clone();
  col = rt.getColumnHeadings().split("\t");
  n = rt.size();
  overlay = img.getOverlay();
  if (overlay.size()!=n) print(msg+1);

  // Compare particle analyze results to measured overlay ROIs
  Analyzer.setMeasurements(Measurements.ALL_STATS+Measurements.LIMIT);
  rt2 = ResultsTable.getResultsTable();
  for (i=0; i<n; i++) {
     roi = overlay.get(i);
     img.setRoi(roi);
     IJ.run(img, "Measure", "");
     for (c=1; c<col.length; c++)
        compare("Overlay", i, col[c], rt.getValue(col[c],i), rt2.getValue(col[c],i));
  }

  // Compare particle analyze results to measured ROI Manager ROIs
  img.deleteRoi();
  rm = RoiManager.getInstance();
  IJ.run("Clear Results", "");
  rt2 = ResultsTable.getResultsTable();
  for (i=0; i<n; i++) {
     rm.select(img, i);
     IJ.run(img, "Measure", "");
     for (c=1; c<col.length; c++)
        compare("ROI Manager", i, col[c], rt.getValue(col[c],i), rt2.getValue(col[c],i));
  }

  Analyzer.setMeasurements(saveMeasurements);
  rm.close();
  IJ.selectWindow("Results");
  IJ.run("Close");

  function compare(test, row, column, value1, value2) {
     tolerance = 0.0000001;
     if (Math.abs(value1-value2)>tolerance || (!Double.isNaN(value1)&&Double.isNaN(value2)) )
        print("Error ("+test+"):  "+row+"  "+column+"  "+value1+"  "+value2);
  }
